var FillChart = function(ele, opt) {
	this.$ele = $(ele);
	this.options = opt;
}
FillChart.prototype = {
	init: function() {
		var myChart = echarts.init(document.getElementById(this.$ele.attr('id')));
		if(this.options.type == 'pie'){
			myChart.setOption(this.pie());
		}
		if(this.options.type == 'line'){
			myChart.setOption(this.line());
		}
		if(this.options.type == 'dateZoomline'){
			myChart.setOption(this.dateZoomline());
		}
	},
	line:function(){
		var _option = {
            tooltip: {
				show:false,
			},
			grid:{
				left:'0',
				top:'30',
				right:'0',
				bottom:'0',
				containLabel:true
			},
            xAxis: {
				axisLine: {
					show : false
				},
				axisTick:{
					show : false
				},
				axisLabel:{
					show:true,
					interval:0,
					textStyle:{
						color:'#a2b0b3'
					}
				},
                data: [NDays(4),NDays(3),NDays(2),NDays(1),NDays(0)]
            },
            yAxis: {
            	position:'left',
				axisLine: {
					show : false
				},
				axisTick:{
					show : false
				},
				axisLabel:{
					textStyle:{
						color:'#a2b0b3'
					}
				},
				splitNumber:3,
				splitLine:{
					lineStyle:{
						color:'#607884'
					}
				}
			},
            series: [{
                type: 'line',
				symbol:'image://../static/img/yuan01.png',
				symbolSize: 10,
				legendHoverLink:true,
				label : {
					normal: {
						show: true,
						textStyle:{
							color:'#fff',
							fontStyle: 'normal',
							fontWeight: 400,
							fontFamily: 'sans-serif',
							fontSize: 13,
						}
					}
				},
				connectNulls:false,//是否连接空数据
                data: [],
				lineStyle: {
					normal:{
						color:'#2694eb',
						width:3,
						type:'solid'
					}
				},
				smooth:true
            },{
                type: 'line',
                symbolSize:0,
				label : {
					normal: {
						show: false
					}
				},
				connectNulls:false,
                data: [],
				lineStyle: {
					normal:{
						color:'#9ccdf5',
						width:3,
						type:'dettod'
					}
					
				},
				smooth:true
            }]
        };
		_option = $.extend(true,{},_option,this.options.data);
		this.options.showtips == false ? _option.series[0].symbolSize = 0 : _option.series[0].symbolSize = 10;
		return _option;
	},
	dateZoomline: function(){
		var _option = {
            tooltip: {
				show:false,
				position: function (point, params, dom) {
					return [point[0]-45, point[1]-40];
				},
				backgroundColor:"",
				formatter:'<p style="display:inline-block;padding-bottom:10px;background:url(../static/img/label1.png) no-repeat bottom center;background-size:13px 10px;"><span style="padding:3px 5px;background-color:#2692ea;border-radius:14px">{c0}</span></p>',
				trigger:'trigger'
			},
			grid:{
				left:'left',
				top:'10',
				right:'0',
				bottom:'0',
				containLabel:true
			},
            xAxis: {
				axisLine: {
					show : false
				},
				axisTick:{
					show : false
				},
				axisLabel:{
					textStyle:{
						color:'#fff'
					}
				},
				splitNumber:7,
				splitLine:{
					interval:0,
					lineStyle:{
						color:'#607884'
					}
				},
                data: []
            },
            yAxis: {
				axisLine: {
					show : false
				},
				axisTick:{
					show : false
				},
				axisLabel:{
					inside:true,
					textStyle:{
						color:'#fff'
					}
				},
				splitNumber:3
			},
			dataZoom:[
				{
					type: 'inside',
					show: true,
					startValue:(new Date().getMonth()-5)+"月",
					endValue:(new Date().getMonth()+1)+"月"
				}
			],
            series: [{
                type: 'line',
				symbolSize: 0,
				legendHoverLink:true,
				label : {
					normal: {
						show: false,
						textStyle:{
							color:'#fff',
							fontStyle: 'normal',
							fontWeight: 400,
							fontFamily: 'sans-serif',
							fontSize: 20,
						}
					}
				},
				connectNulls:true,
                data: [],
				lineStyle: {
					normal:{
						color:'#2694eb',
						width:2,
						type:'solid'
					}
					
				},
				markPoint:{
					data: [
						{
							symbol:'image://../static/img/label.png',
							symbolSize:[90,43],
							symbolOffset:[0, '-150%'],
							itemStyle:{
								normal:{
									color:'#fff'
								}
							},
							label:{
								normal:{
									color:'#fff',
									position:[10,8],
									textStyle:{
										fontSize:16
									}
								}
							}
						}
					]
				},
				smooth:true
            },{
                type: 'line',
				symbolSize: 0,
				legendHoverLink:true,
				label : {
					normal: {
						show: false,
						textStyle:{
							color:'#fff',
							fontStyle: 'normal',
							fontWeight: 400,
							fontFamily: 'sans-serif',
							fontSize: 20,
						}
					}
				},
				connectNulls:true,
                data: [],
				lineStyle: {
					normal:{
						color:'#a0d3f2',
						width:2,
						type:'solid'
					}
					
				},
				markPoint:{
					data: [
						{
							symbol:'image://../static/img/label.png',
							symbolSize:[90,43],
							symbolOffset:[0, '-150%'],
							itemStyle:{
								normal:{
									color:'#fff'
								}
							},
							label:{
								normal:{
									color:'#fff',
									position:[10,8],
									textStyle:{
										fontSize:16
									}
								}
							}
						}
					]
				},
				smooth:true
            }]
        };
		_option = $.extend(true,{},_option,this.options.data);
		return _option;
	},
	pie: function(){
		var _this = this;
		var label = {normal:{position:'inside',textStyle:{fontSize: 12}}};
		for(i = 0;i < this.options.data.length; i++){
			this.options.data[i].label = label;
		}
		var _option = {
				series : [
					{
			            type: 'pie',
			            clockwise: false,
			            hoverAnimation:false,
			            radius : '85%', //控制饼图大小
			            center: ['50%', '50%'],
			            selectedOffset : 5,
			            data:_this.options.data,
			            color:[new echarts.graphic.LinearGradient(0, 0, 0, 1, [{offset:0, color:'#42a6f4'}, {offset:1, color:'#308bd4'}], false),'#9ecef4'],
			            itemStyle: {
			                emphasis: {
			                    shadowBlur: 10,
			                    shadowOffsetX: 0,
			                    shadowColor: 'rgba(0, 0, 0, 0.5)'
			                }
			            }
			        }
			    ]
		};
		return _option;
	}
}
;(function() {
	$.fn.setCharts = function(options) {
		$(this).each(function(){
			var Fill = new FillChart(this,options);
			Fill.init();
		})
	}
})(jQuery);



//是否是小数，是：2，否：0
function hasDot(num) {
	if (!isNaN(num)) {
		return ((num + '').indexOf('.') != -1) ? 2 : 0;
	}
}
var NDays = function(n){
	var time = new Date();
	var newTime=time-n*24*60*60*1000;
	var _date = new Date(newTime);
	var _m = (_date.getMonth()+1) < 10 ?  "0"+(_date.getMonth()+1) : (_date.getMonth()+1);
	var _day = _date.getDate()<10 ?  "0"+ _date.getDate() : _date.getDate();
	return _m+'/'+_day;
};
var Mdays = function(n){
	var time = new Date();
	var _y = time.getFullYear();
	var _m = time.getMonth() + 1 - n % 12 ;
	_m = _m <= 0 ? 12 + _m : _m;
	if(time.getMonth()+ 1 - n <= 0){
		_y = _y - 1 - Math.floor((n - time.getMonth() - 1) / 12);
	}
	_m = _m < 10 ?  "0"+_m : _m;
	return _y+'/'+ _m;
}
var FDays = function(n){
	var time = new Date();
	var newTime=time-n*24*60*60*1000;
	var _date = new Date(newTime);
	var _m = (_date.getMonth()+1) < 10 ?  "0"+(_date.getMonth()+1) : (_date.getMonth()+1);
	var _day = _date.getDate()<10 ?  "0"+ _date.getDate() : _date.getDate();
	return _date.getFullYear()+'/'+_m+'/'+_day;
};