/**
 * 升级
 *
 */
var server="http://ytt.xuanye100.com:8818/download/BossUpdate.json",//获取升级描述文件服务器地址
localDir="update",localFile="BossUpdate.json",//本地保存升级描述目录和文件名
keyUpdate="updateCheck",//取消升级键名
keyAbort="updateAbort",//忽略版本键名
checkInterval=0,//604800000,//升级检查间隔，单位为ms,7天为7*24*60*60*1000=604800000, 如果每次启动需要检查设置值为0
dir=null;
var callback = function(){
	return;
};
/**
 * 准备升级操作
 * 创建升级文件保存目录
 */
function initUpdate(_callBack){
	// 在流应用模式下不需要检测升级操作
	if(typeof _callBack == "function"){
		callback = _callBack;
	}
	if(navigator.userAgent.indexOf('StreamApp')>=0){
		return;
	}
	// 打开doc根目录
	plus.io.requestFileSystem( plus.io.PRIVATE_DOC, function(fs){
		fs.root.getDirectory( localDir, {create:true}, function(entry){
			dir = entry;
			checkUpdate();
		}, function(e){
			console.log( "准备升级操作，打开update目录失败："+e.message );
			callback();
		});
	},function(e){
		console.log( "准备升级操作，打开doc目录失败："+e.message );
		callback();
	});
}

/**
 * 检测程序升级
 */
function checkUpdate() {
	// 判断升级检测是否过期
	var lastcheck = plus.storage.getItem( keyUpdate );
	if ( lastcheck ) {
		var dc = parseInt( lastcheck );
		var dn = (new Date()).getTime();
		if ( dn-dc < checkInterval ) {	// 未超过上次升级检测间隔，不需要进行升级检查
			callback();
			return;
		}
		// 取消已过期，删除取消标记
		plus.storage.removeItem( keyUpdate );
	}
	// 读取本地升级文件
	dir.getFile( localFile, {create:false}, function(fentry){
		fentry.file( function(file){
			var reader = new plus.io.FileReader();
			reader.onloadend = function ( e ) {
				fentry.remove();
				var data = null;
				try{
					data=JSON.parse(e.target.result);
				}catch(e){
					console.log( "读取本地升级文件，数据格式错误！" );
					callback();
					return;
				}
				checkUpdateData(data);
			}
			reader.readAsText(file);
		}, function(e){
			console.log( "读取本地升级文件，获取文件对象失败："+e.message );
			fentry.remove();
			callback();
		} );
	}, function(e){
		// 失败表示文件不存在，从服务器获取升级数据
		getUpdateData();
	});
}

/**
 * 检查升级数据
 */
function checkUpdateData( j ){
	var curVer=null,inf = j[plus.os.name];
	plus.runtime.getProperty(plus.runtime.appid, function(wgtinfo) {
	    curVer = wgtinfo.version;
		if (inf){
			var srvVer = inf.version;
			// 判断是否存在忽略版本号
			var vabort = plus.storage.getItem( keyAbort );
			if ( vabort && srvVer==vabort ) {
				// 忽略此版本
				return;
			}
			console.log(curVer+","+srvVer+":"+compareVersion(curVer,srvVer))
			// 判断是否需要升级
			if ( compareVersion(curVer,srvVer) ) {
				plus.io.requestFileSystem(plus.io.PUBLIC_DOWNLOADS, function(fs) {
					var directoryReader = fs.root.createReader();
					directoryReader.readEntries( function( entries ){
						for( i=0; i < entries.length; i++ ) {
							console.log(entries[i].name)
							entries[i].remove();
						}
					});
		        });
				// 提示用户是否升级
				if(inf.upType == 1){
					 plus.nativeUI.alert(inf.title, function() {
					 	plus.nativeUI.showWaiting("文件下载中...");
						plus.downloader.createDownload( inf.url, {}, function ( d, status ) {
						    if ( status == 200 ) { //下载成功
						        var path = d.filename;
						        installWgt(path,inf.upType,inf.packageType);
						    } else {//下载失败
						        console.log( "Download failed: " + status ); 
						        callback();
						    }
						   plus.nativeUI.closeWaiting();
						}).start();
			        });
				}
				if(inf.upType == 2) {
					plus.nativeUI.confirm( inf.note, function(i){
						if ( 0==i.index ) {
							plus.nativeUI.showWaiting("文件下载中...");
							plus.downloader.createDownload( inf.url, {filename:plus.io.PUBLIC_DOWNLOADS}, function ( d, status ) {
							    if ( status == 200 ) { //下载成功
							        var path = d.filename;
							        installWgt(path,inf.upType,inf.packageType);
							    } else {//下载失败
							        console.log( "Download failed: " + status ); 
							        callback();
							    }
							   plus.nativeUI.closeWaiting();
							}).start();
						} else if ( 1==i.index ) {
							plus.storage.setItem( keyAbort, srvVer );
							plus.storage.setItem( keyUpdate, (new Date()).getTime().toString() );
							callback();
						} else {
							plus.storage.setItem( keyUpdate, (new Date()).getTime().toString() );
							callback();
						}
					}, inf.title, ["立即更新","跳过此版本","取　　消"] );
				}
//				if(inf.upType == 3){
//					plus.downloader.createDownload( inf.url, {}, function ( d, status ) {
//					    if ( status == 200 ) { //下载成功
//					        var path = d.filename;
//					        installWgt(path,inf.upType,inf.packageType);
//					    } else {//下载失败
//					        console.log( "Download failed: " + status );
//					        callback();
//					    }
//					   plus.nativeUI.closeWaiting();
//					}).start();
//				}
				
				
			}else{
				callback();
			}
		}
	});
}
/**
 * 从服务器获取升级数据
 */
function getUpdateData(){
	var xhr = new plus.net.XMLHttpRequest();
	xhr.onreadystatechange = function () {
        switch ( xhr.readyState ) {
            case 4:
                if ( xhr.status == 200 ) {
                	// 保存到本地文件中
                	dir.getFile( localFile, {create:true}, function(fentry){
                		fentry.createWriter( function(writer){
                			writer.onerror = function(){
                				console.log( "获取升级数据，保存文件失败！" );
                				callback();
                			}
                			writer.write( xhr.responseText );
                			console.log( "获取升级数据，保存文件成功！" );
                			checkUpdate();
                		}, function(e){
                			console.log( "获取升级数据，创建写文件对象失败："+e.message );
                			callback();
                		} );
                	}, function(e){
                		console.log( "获取升级数据，打开保存文件失败："+e.message );
                		callback();
                	});
                } else {
                	console.log( "获取升级数据，联网请求失败："+xhr.status );
                	callback();
                }
                break;
            default :
                break;
        }
	}
	xhr.open( "GET", server );
	xhr.send();
}

/**
 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean} 
 */
function compareVersion( ov, nv ){
	if ( !ov || !nv || ov=="" || nv=="" ){
		return false;
	}
	var b=false,
	ova = ov.split(".",4),
	nva = nv.split(".",4);
	for ( var i=0; i<ova.length&&i<nva.length; i++ ) {
		var so=ova[i],no=parseInt(so),sn=nva[i],nn=parseInt(sn);
		if ( nn>no || sn.length>so.length  ) {
			return true;
		} else if ( nn<no ) {
			return false;
		}
	}
	if ( nva.length>ova.length && 0==nv.indexOf(ov) ) {
		return true;
	}
}

  // 更新应用资源

function installWgt(path,upType,packageType) {
	if(upType != 3)plus.nativeUI.showWaiting("安装资源文件...");
	plus.runtime.install(path, {force: true}, function() {
      	if(upType != 3 && packageType != "install"){
      		plus.nativeUI.closeWaiting();
	        plus.nativeUI.alert("应用资源更新完成！", function() {
	            plus.runtime.restart();
	        });
      	}
   }, function(e) {
        console.log("失败[" + e.code + "]：" + e.message);
        if(upType != 3 && packageType != "install"){
        	plus.nativeUI.closeWaiting();
        	plus.nativeUI.alert("在线升级，安装资源文件失败");
        }
    });
}
